/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.java.net
 * SCM: https://bitbucket.org/tidalwave/openbluesky-src
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.capabilitiesprovider;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.ThreadSafe;
import java.util.Collection;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * @deprecated Use RoleProvider instead
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Deprecated
@ThreadSafe
public interface CapabilitiesProvider<T> 
  {
    /*******************************************************************************************************************
     *
     * Return the managed object class.
     * 
     * @return              the managed class
     *
     ******************************************************************************************************************/
    @Nonnull
    public Class<T> getManagedClass();
    
    /*******************************************************************************************************************
     *
     * Provides capabilities for the managed object as a collection of plain objects.
     * 
     * @param  owner        the <code>owner</code>
     * @return              the capabilities
     *
     ******************************************************************************************************************/
    @Nonnull
    public Collection<? extends Object> createCapabilities (@Nonnull T owner);
    
    /*******************************************************************************************************************
     *
     * Provides capabilities for the managed object as {@link Lookup} instances.
     * 
     * @param  owner        the <code>owner</code>
     * @return              the <code>Lookup</code>s
     *
     ******************************************************************************************************************/
    @Nonnull
    public Collection<? extends Lookup> createLookups (@Nonnull T owner);
  }
